// Immediately-invoked function expression
(function(){
    const HOST_URL='https://xteract.com'
    const CURRENT_HOST = window.location.host;

    // Load the script
    const script = document.createElement("script");
    script.src = 'https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js';
    script.type = 'text/javascript';
    script.addEventListener('load', async () => {
        console.log(`jQuery ${$.fn.jquery} has been loaded successfully!`);

        // use jQuery below
        $('head').append(`<link rel="stylesheet" type="text/css" href="${HOST_URL}/css/embed.css">`);

        // ---------------------
        let WIDGET_ID = '';

        $('script').each(function(i, el){
            if($(this).attr('board-app-widget')){
                WIDGET_ID = $(this).attr('board-app-widget')
            }
        })

        const fetchWidget = async () => {
            await fetch(`${HOST_URL}/api/widget/show/${WIDGET_ID}`)
                .then(res => res.json())
                .then(res => {
                    // Check if widget has domain restriction
                    let website = res.data.website;
        
                    if(website && new URL(website).host == CURRENT_HOST){
                        setWidgetElement(res)
                    }else if(!website){
                        setWidgetElement(res)
                    }
                })
                .catch(err => {})
        }

        // --------------

        await fetchWidget();

        $('#open-nav').on('click', function() {
            let sidePanel = $('#mySidepanel')
            if(sidePanel.is(':hidden')) {
                sidePanel.show().fadeIn('slow')
            }else {
                sidePanel.hide().fadeOut('slow')
            }
        })

        $('#close-nav').on('click', function() {
            $('#mySidepanel').hide().fadeOut('slow')
        })
    });
    document.head.appendChild(script);
})();

// --------------------------------------------------
const HOST_URL = 'https://xteract.com'

// CREATE WIDGET ELEMENT
const setWidgetElement = (res) => {
    let data = res.data;
    let widgetIcon = `<div class="widget-container">
            <div class="float-btn" id="open-nav" style="border-radius: ${data.layout == 'square' ? '12.5px':'50px'}; width: ${data.layoutWidth}px; height: ${data.layoutHeight}px; background-image: url('${HOST_URL}/${data.logo}');background-size: contain;background-position: center;background-repeat: repeat;">
                <div class="overlay" style="border-radius: ${data.layout == 'square' ? '12.5px':'50px'}; width: ${data.layoutWidth}px; height: ${data.layoutHeight}px;">
                    <span style="margin: auto;">Click to expand</span>
                </div>
            </div>
        </div>`;

    $('body').append(widgetIcon)

    if(data.flow){
        let flowWidget = `<div id="mySidepanel" class="sidepanel" style="width:350px; padding: 10px; display:none;">
            <div class="inline-block" style="display:flex; justify-content: right; position:absolute; right: 10px;">
                <a href="${HOST_URL}/${data.flow.url_tag}" title="Preview" target="_blank" id="visit-nav" style="padding: 3px;">
                    <svg xmlns="http://www.w3.org/2000/svg" fill="none" height="24" viewBox="0 0 24 24" width="24"><path d="M10 6H6C4.89543 6 4 6.89543 4 8V18C4 19.1046 4.89543 20 6 20H16C17.1046 20 18 19.1046 18 18V14M14 4H20M20 4V10M20 4L10 14" stroke="#4A5568" stroke-linecap="round" stroke-linejoin="round" stroke-width="2"/></svg>
                </a>
                <span class="" id="close-nav" style="padding: 3px;" title="Close">
                    <svg xmlns="http://www.w3.org/2000/svg" height="24" viewBox="0 0 24 24" width="24" fill="#000000"><path d="M0 0h24v24H0V0z" fill="none" /><path d="M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41z"/></svg>
                </span>
            </div>
            <iframe title="Flow preview" src="${HOST_URL}/render/${data.flow.flow_hash}?host=${window.location.host}" scrolling="no" frameborder="0" allow="autoplay; camera; microphone" style="background: var(--body_color); width: 100%; height: 100%; border-radius: inherit;"></iframe>
        </div>
        `
        $('body').append(flowWidget)
    }
}

